Subject: bug#8951: [External] : Re: bug#8951: 24.0.50; [PATCH] enhancement request: buttonize key names

From: Drew Adams <[email-masked]>
Date: Mon, 25 Oct 2021 01:32:53 +0000

> > Grep even just the vanilla Emacs-Lisp sources for
> > `substitute-command-keys'.  It's not used only for
> > *Help*.  And then think about uses by other code,
> > besides vanilla Emacs.
> 
> I only see a lot of places where we want whatever the user
> has configured, none where we need an optional argument.
>
> > What's the reason you prefer not to?  I don't
> > understand.  Maybe you have a good reason, but
> > I don't think you gave any (?).
> 
> I'm repeating myself here: 

Actually, though you may be repeating, you still
haven't given a reason for your preference.  It's
OK with me if you have no reason - just wanted to
understand, in case I was missing something.

> I'm actually happy to add it, if we have a
> use-case.  How about we try this for a start,
> and once users start using
> this in the wild, they'll come back to us and say: hey I really want an
> optional parameter here.  Then we think about if that makes sense for
> their use-case, maybe it will, maybe it won't.  But at least we know
> what we are trying to do.
> 
> The alternative is that we add stuff just because "maybe someone will
> need it".  That leads to feature creep, bloat, and is just not a good
> way to develop software.

An alternative is to not add a user option for
this just because maybe some user will need it.
You know - feature creep, bloat...

And to give users who write Lisp code the
ability to buttonize or not, wherever they use
`substitute-command-keys'.
___

That's what I did in help-fns+.el.  Never had
anyone request a user option to not have the
links.  Since 2011 - ten years in the wild.

Of course, I'd have had nothing against adding
an option for that, if users came back to me
and said: hey I really want a option for it.

In general, I'm not one who's particularly
opposed to dynamic global variables, or even to
binding them to affect behavior.  But in this
case I thought an arg was sufficient.
___

FWIW, you'll notice that there are several uses
of the original, vanilla `substitute-command-keys'
in help-fns+.el.  I don't recall the details, but
no doubt I thought those occurrences should not
buttonize key descriptions.